﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.AccessControl;
using System.Text;
using System.Threading.Tasks;
using UltimateOrb;

namespace PSO2SERVER.Models
{
    // Enum for ItemAttributes
    public enum ItemAttributes
    {
        PC,
        Vita
    }

    // Base class for ItemAttributes
    [Serializable]
    public class ItemAttributesBase
    {
        public uint Unk1 { get; set; }
        public UInt128 Unk2 { get; set; }
    }

    // PC ItemAttributes (NA and JP client)
    [Serializable]
    public class ItemAttributesPC : ItemAttributesBase
    {
        public List<WeaponAttrs> Weapons { get; set; } = new List<WeaponAttrs>();
        public List<HumanCostume> HumanCostumes { get; set; } = new List<HumanCostume>();
        public List<CastPart> CastParts { get; set; } = new List<CastPart>();
        public List<Consumable> Consumables { get; set; } = new List<Consumable>();
        public List<Data5> Data5 { get; set; } = new List<Data5>();
        public List<Unit> Data6 { get; set; } = new List<Unit>();
        public List<Data7> Data7 { get; set; } = new List<Data7>();
        public List<Data8> Data8 { get; set; } = new List<Data8>();
        public List<Data9> Data9 { get; set; } = new List<Data9>();
        public List<Data10> Data10 { get; set; } = new List<Data10>();
        public List<Data11> Data11 { get; set; } = new List<Data11>();
        public List<Data12> Data12 { get; set; } = new List<Data12>();
        public List<Data13> Data13 { get; set; } = new List<Data13>();
        public List<Data14> Data14 { get; set; } = new List<Data14>();
        public List<Data15> Data15 { get; set; } = new List<Data15>();
        public List<Data16> Data16 { get; set; } = new List<Data16>();
        public List<Data17> Data17 { get; set; } = new List<Data17>();
        public List<ShortData> Data18 { get; set; } = new List<ShortData>();  // Fixed length can be manually handled
        public List<Data19> Data19 { get; set; } = new List<Data19>();
        public List<Data20> Data20 { get; set; } = new List<Data20>();
    }

    // Vita ItemAttributes (Vita client)
    [Serializable]
    public class ItemAttributesVita : ItemAttributesBase
    {
        public List<WeaponAttrs> Weapons { get; set; } = new List<WeaponAttrs>();
        public List<HumanCostume> HumanCostumes { get; set; } = new List<HumanCostume>();
        public List<CastPart> CastParts { get; set; } = new List<CastPart>();
        public List<Consumable> Consumables { get; set; } = new List<Consumable>();
        public List<Data5> Data5 { get; set; } = new List<Data5>();
        public List<Unit> Data6 { get; set; } = new List<Unit>();
        public List<Data7> Data7 { get; set; } = new List<Data7>();
        public List<Data8> Data8 { get; set; } = new List<Data8>();
        public List<Data9> Data9 { get; set; } = new List<Data9>();
        public List<Data10> Data10 { get; set; } = new List<Data10>();
        public List<Data11> Data11 { get; set; } = new List<Data11>();
        public List<Data12> Data12 { get; set; } = new List<Data12>();
        public List<Data13> Data13 { get; set; } = new List<Data13>();
        public List<Data14> Data14 { get; set; } = new List<Data14>();
        public List<Data15> Data15 { get; set; } = new List<Data15>();
        public List<Data16> Data16 { get; set; } = new List<Data16>();
        public List<Data17> Data17 { get; set; } = new List<Data17>();
        public List<ShortData> Data18 { get; set; } = new List<ShortData>();  // Fixed length can be manually handled
        public List<Data19Vita> Data19 { get; set; } = new List<Data19Vita>();
        public List<Data20> Data20 { get; set; } = new List<Data20>();
    }

    // Example of a simple class, could be for one of the referenced types
    [Serializable]
    public class WeaponAttrs
    {
        // Item category
        public ushort Id { get; set; }

        // Item ID
        public ushort Subid { get; set; }
        public byte Unk1 { get; set; }
        public byte Priority { get; set; }
        public byte Unk2 { get; set; }
        public byte Priority2 { get; set; }

        // Item rarity in stars
        public byte Rarity { get; set; }
        public ushort Flags { get; set; }
        public byte Unk3 { get; set; }
        public ushort IconList { get; set; }
        public ushort IconIndex { get; set; }

        // Range damage
        public ushort RangeDmg { get; set; }
        public byte Unk4 { get; set; }

        // Melee damage
        public ushort MeleeDmg { get; set; }
        public byte Unk5 { get; set; }
        public uint Unk6 { get; set; }

        // Force damage and equipable genders
        public GenderDmg GenderForceDmg { get; set; }

        public byte[] Unk8 { get; set; } = new byte[4];

        // Equipable races
        public RaceFlags Race { get; set; }
        public byte Flags2 { get; set; }

        // Equipable classes
        public ClassFlags Class { get; set; }

        // Required stat value
        public ushort ReqStat { get; set; }

        // Required stat type
        public StatType ReqStatType { get; set; }

        public byte Unk9 { get; set; }
        public ushort Model { get; set; }
        public uint Unk10 { get; set; }
        public ushort Unk11 { get; set; }
        public ushort AffixFlag { get; set; }
        public ushort Unk12 { get; set; }
    }

    [Serializable]
    public class HumanCostume
    {
        // Properties specific to HumanCostume
    }

    [Serializable]
    public class CastPart
    {
        // Properties specific to CastPart
    }

    [Serializable]
    public class Consumable
    {
        // Properties specific to Consumable
    }

    [Serializable]
    public class Data5
    {
        // Properties specific to Data5
    }

    // More data types (e.g., Data7, Data8, etc.) need to be created similarly
    public class Unit { }
    public class Data7 { }
    public class Data8 { }
    public class Data9 { }
    public class Data10 { }
    public class Data11 { }
    public class Data12 { }
    public class Data13 { }
    public class Data14 { }
    public class Data15 { }
    public class Data16 { }
    public class Data17 { }
    public class ShortData { }
    public class Data19 { }
    public class Data19Vita { }
    public class Data20 { }
    public struct GenderDmg
    {
        /// Force damage.
        public ushort force_dmg;
        /// Equipable genders.
        public Gender gender;
    }

    public enum StatType
    {
        // MEL power.
        MELPwr = 0,

        // RNG power.
        RNGPwr = 1,

        // TEC power.
        TECPwr = 2,

        // DEX.
        DEX = 3,

        // MEL defence.
        MELDef = 4,

        // RNG defence.
        RNGDef = 5,

        // TEC defence.
        TECDef = 6
    }

    public static class StatTypeExtensions
    {
        public static StatType Default => StatType.MELPwr;
    }
}
